<?php
/**
*
* @package Simple Karma PHP Code
* @version 1.0.2 of 10.07.2013
* @copyright (c) By Shapoval Andrey Vladimirovich (AllCity) ~ http://web-codes.net/
* @license http://opensource.org/licenses/gpl-license.php GNU Public License
*
**/

/**
* DO NOT CHANGE (IN_PHPBB)!
*/
define('IN_PHPBB', true);

// Custom Page code from http://www.phpbb.com/kb/article/add-a-new-custom-page-to-phpbb/
$phpbb_root_path = (defined('PHPBB_ROOT_PATH')) ? PHPBB_ROOT_PATH : './';
$phpEx = substr(strrchr(__FILE__, '.'), 1);
include($phpbb_root_path.'common.'.$phpEx);

// Start session management.
$user->session_begin();
$auth->acl($user->data);
$user->setup('mods/karma_lang');

// If Guest jump to login box ;)
if(!$user->data['is_registered'])
{
  // Login box...
  login_box('', $user->lang['LOGIN']);
}

// Options (global)
$karma_time_limit = 12; /* One karma point after time in hour (recommended from 6 to 24). (set 0 to disable) */
$karma_pminfo = true; /* Send PM if karma changed */
$karma_secret_code = 'EKNvMXhxCx2Gz4S'; /* Secret code for installation and removal Simple Karma from a database (only latin letters and numbers). */

// Options (admin)
$karma_admin_no_limit = true; /* Allow ignore karma limit? */

// Options (moder)
$karma_moder_no_limit = true; /* Allow ignore karma limit? */

// Options (user)
$karma_user_allow_sum = true; /* Allow change karma? */
$karma_user_no_limit = false; /* Allow ignore karma limit? */

// Access rights (generated from options)
$karma_no_limit = (($karma_admin_no_limit && $auth->acl_get('a_')) || ($karma_moder_no_limit && $auth->acl_get('m_')) || ($karma_user_no_limit && $auth->acl_get('u_') && $user->data['is_registered'])) ? true : false;
$karma_allow_sum = (($karma_user_allow_sum && $auth->acl_get('u_') && $user->data['is_registered'])) ? true : false;
$karma_founder = ($user->data['user_type'] != USER_FOUNDER) ? false : true;

// Reguest
$karma_mode = request_var('mode', '');
$karma_to = request_var('to', ANONYMOUS);
$karma_post = request_var('post', 0);
$karma_secret_code_req = request_var('code', '');

// Redirect URL
$karma_redirect = append_sid("{$phpbb_root_path}viewtopic.$phpEx", 'p='.$karma_post.'#p'.$karma_post);
$karma_redirect_index = append_sid("{$phpbb_root_path}index.$phpEx");

// Not karma for self or bots and user id 1 (anonymous)
if($karma_mode == 'minus' || $karma_mode == 'plus')
{
  $sql = 'SELECT user_ip FROM '.USERS_TABLE.' WHERE user_id = '.$karma_to.' LIMIT 1';
  $result = $db->sql_query($sql);
  $row = $db->sql_fetchrow($result);
  if($user->data['user_id'] == $karma_to || !$row['user_ip'])
  {
    // Redirect to post page
    meta_refresh(3, $karma_redirect);
    trigger_error($user->lang['KARMA_NOACCESS'].'<br /><br />'.sprintf($user->lang['RETURN_PAGE'], '<a href="'.$karma_redirect.'">', '</a>'), E_USER_NOTICE);
  }
  $db->sql_freeresult($result);
}

// Request mode...
switch($karma_mode)
{
  // Install DB function...
  case 'install':
    // User logged in?
    if(!$user->data['is_registered'])
    {
      // Login box...
      login_box('', $user->lang['LOGIN']);
    }
      // No founder!
      else if(!$karma_founder)
    {
      // Show not authorized box
      trigger_error('NO_AUTH_OPERATION', E_USER_WARNING);
    }
      // Founder!
      else if($karma_founder && $karma_secret_code == $karma_secret_code_req)
    {
      // Run install db!
      $sql = 'ALTER TABLE '.USERS_TABLE.' ADD karma_user_sum mediumint(8) NOT NULL default \'0\', ADD karma_last_time int(11) unsigned NOT NULL default \'0\'';
      $db->sql_query($sql);
      // Show OK box and redirect to index page
      meta_refresh(3, $karma_redirect_index);
      trigger_error($user->lang['KARMA_INSTALLOK'].'<br /><br />'.sprintf($user->lang['RETURN_INDEX'], '<a href="'.$karma_redirect_index.'">', '</a>'), E_USER_NOTICE);
    }
      else
    {
      // Show error box...
      trigger_error('KARMA_INSTALLERROR', E_USER_ERROR);
    }
  break;

  // Uninstall DB function...
  case 'uninstall':
    // User logged in?
    if(!$user->data['is_registered'])
    {
      // Login box...
      login_box('', $user->lang['LOGIN']);
    }
      // No founder!
      else if(!$karma_founder)
    {
      // Show not authorized
      trigger_error('NO_AUTH_OPERATION', E_USER_WARNING);
    }
      // Founder!
      else if($karma_founder && $karma_secret_code == $karma_secret_code_req)
    {
      // Run Uninstall!
      $sql = 'ALTER TABLE '.USERS_TABLE.' DROP karma_user_sum, DROP karma_last_time';
      $db->sql_query($sql);
      // Show OK box and redirect to index page
      meta_refresh(3, $karma_redirect_index);
      trigger_error($user->lang['KARMA_UNINSTALLOK'].'<br /><br />'.sprintf($user->lang['RETURN_INDEX'], '<a href="'.$karma_redirect_index.'">', '</a>'), E_USER_NOTICE);
    }
      else
    {
      // Show error box...
      trigger_error('KARMA_UNINSTALLERROR', E_USER_ERROR);
    }
  break;

  // Plus function
  case 'plus':
    // Box
    if(confirm_box(true))
    {
      // If change karma not alowed
      if(!$karma_allow_sum)
      {
        // Redirect to post page
        meta_refresh(3, $karma_redirect);
        trigger_error($user->lang['KARMA_NOACCESS'].'<br /><br />'.sprintf($user->lang['RETURN_PAGE'], '<a href="'.$karma_redirect.'">', '</a>'), E_USER_NOTICE);
      }
      // Karma limit timer
      if(!$karma_no_limit)
      {
        if($user->data['karma_last_time'] > 0 && (time() - $user->data['karma_last_time']) < 3600 * $karma_time_limit)
        {
          // Redirect to post page
          meta_refresh(3, $karma_redirect);
          trigger_error($user->lang['KARMA_TIME'].'<br /><br />'.sprintf($user->lang['RETURN_PAGE'], '<a href="'.$karma_redirect.'">', '</a>'), E_USER_NOTICE);
        }
      }
      // Core +
      $sql = 'UPDATE '.USERS_TABLE.' SET karma_user_sum = karma_user_sum + 1 WHERE user_id = '.$karma_to;
      $db->sql_query($sql);
      // Karma limit by time
      $sql = 'UPDATE '.USERS_TABLE.' SET karma_last_time = '.time().' WHERE user_id = '.$user->data['user_id'];
      $db->sql_query($sql);
      // Send PM info
      if($karma_pminfo)
      {
        if (!function_exists('submit_pm'))
        {
        	include($phpbb_root_path.'includes/functions_privmsgs.'.$phpEx);
        }
        // Hold the parameters for submit_pm()
        $pm_text = sprintf($user->lang['KARMA_PMMESSPLUS'], append_sid(generate_board_url().'/memberlist.'.$phpEx, 'mode=viewprofile&amp;u='.$user->data['user_id']), $user->data['username'], append_sid(generate_board_url().'/viewtopic.'.$phpEx, 'p='.$karma_post.'#p'.$karma_post));
        $poll = $uid = $bitfield = $options = ''; 
        generate_text_for_storage($pm_text, $uid, $bitfield, $options, true, true, true);
        $pm_data = array( 
          'address_list' => array ('u' => array($karma_to => 'to')),
          'from_user_id' => $user->data['user_id'],
          'from_username' => $user->data['username'],
          'icon_id' => 0,
          'from_user_ip' => $user->data['user_ip'],
          'enable_bbcode' => true,
          'enable_smilies' => true,
          'enable_urls' => true,
          'enable_sig' => false,
          'message' => $pm_text,
          'bbcode_bitfield' => $bitfield,
          'bbcode_uid' => $uid
        );
        // Senddddd PM :)
        submit_pm('post', $user->lang['KARMA_PMTITLE'], $pm_data, false);
      }
      // Redirect to post page
      meta_refresh(3, $karma_redirect);
      trigger_error($user->lang['KARMA_DONE'].'<br /><br />'.sprintf($user->lang['RETURN_PAGE'], '<a href="'.$karma_redirect.'">', '</a>'), E_USER_NOTICE);
    }
      else
    {
      // Display confirm box
      confirm_box(false, $user->lang['KARMA_PLUS']);
    }
    redirect($karma_redirect);
  break;

  // Minus function
  case 'minus':
    // If change karma not alowed
    if(!$karma_allow_sum)
    {
      // Redirect to post page
      meta_refresh(3, $karma_redirect);
      trigger_error($user->lang['KARMA_NOACCESS'].'<br /><br />'.sprintf($user->lang['RETURN_PAGE'], '<a href="'.$karma_redirect.'">', '</a>'), E_USER_NOTICE);
    }
    // Box
    if(confirm_box(true))
    {
      // Karma limit timer
      if(!$karma_no_limit)
      {
        if($user->data['karma_last_time'] > 0 && (time() - $user->data['karma_last_time']) < 3600 * $karma_time_limit)
        {
          // Redirect to post page
          meta_refresh(3, $karma_redirect);
          trigger_error($user->lang['KARMA_TIME'].'<br /><br />'.sprintf($user->lang['RETURN_PAGE'], '<a href="'.$karma_redirect.'">', '</a>'), E_USER_NOTICE);
        }
      }
      // Core -
      $sql = 'UPDATE '.USERS_TABLE.' SET karma_user_sum = karma_user_sum - 1 WHERE user_id = '.$karma_to;
      $db->sql_query($sql);
      // Karma limit by time
      $sql = 'UPDATE '.USERS_TABLE.' SET karma_last_time = '.time().' WHERE user_id = '.$user->data['user_id'];
      $db->sql_query($sql);
      // Send PM info
      if($karma_pminfo)
      {
        if (!function_exists('submit_pm'))
        {
        	include($phpbb_root_path.'includes/functions_privmsgs.'.$phpEx);
        }
        // Hold the parameters for submit_pm()
        $pm_text = sprintf($user->lang['KARMA_PMMESSMINUS'], append_sid(generate_board_url().'/memberlist.'.$phpEx, 'mode=viewprofile&amp;u='.$user->data['user_id']), $user->data['username'], append_sid(generate_board_url().'/viewtopic.'.$phpEx, 'p='.$karma_post.'#p'.$karma_post));
        $poll = $uid = $bitfield = $options = ''; 
        generate_text_for_storage($pm_text, $uid, $bitfield, $options, true, true, true);
        $pm_data = array( 
          'address_list' => array ('u' => array($karma_to => 'to')),
          'from_user_id' => $user->data['user_id'],
          'from_username' => $user->data['username'],
          'icon_id' => 0,
          'from_user_ip' => $user->data['user_ip'],
          'enable_bbcode' => true,
          'enable_smilies' => true,
          'enable_urls' => true,
          'enable_sig' => false,
          'message' => $pm_text,
          'bbcode_bitfield' => $bitfield,
          'bbcode_uid' => $uid
        );
        // Senddddd PM :)
        submit_pm('post', $user->lang['KARMA_PMTITLE'], $pm_data, false);
      }
      // Redirect to post page
      meta_refresh(3, $karma_redirect);
      trigger_error($user->lang['KARMA_DONE'].'<br /><br />'.sprintf($user->lang['RETURN_PAGE'], '<a href="'.$karma_redirect.'">', '</a>'), E_USER_NOTICE);
    }
      else
    {
      // Display confirm box
      confirm_box(false, $user->lang['KARMA_MINUS']);
    }
    redirect($karma_redirect);
  break;
  
  // By default function
  default:
    // Redirect to post
    meta_refresh(3, $karma_redirect);
    trigger_error($user->lang['KARMA_ERROR'].'<br /><br />'.sprintf($user->lang['RETURN_PAGE'], '<a href="'.$karma_redirect.'">', '</a>'), E_USER_NOTICE);
  break;
}
?>